//	cria - channel operator plugin
//	Copyright (c) 2002-2003 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// local

////////////////////////////////////////////////////////////////////////// PRIVATE


int ban_callback( char *data, int datalen ){ // ban nick from channel
	// BAN nick_or_hostmask

	if(datalen == 0){
		msgCurrentPage(-1, NULL, MF_SYNTAX, 1, "/BAN nick_or_hostmask");
	} else if(p_current->flags.x.chanop){

  // TODO: if only nick is given then
  //	grab hostname for nick, replace the A of A.B.C with * and ban *!*@*.B.C

		netSend(n_current, "MODE %s +b %s\n", p_current->name, data);
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "BAN");

	return(0); // dont passthru
}


int deop_callback( char *data, int datalen ){ // deop nick in channel
	// DEOP [nick nick ...]
	char *nextgroup, mode[5];
	int x;

	if(p_current->flags.x.chanop){
		if(datalen == 0){
			netSend(n_current, "MODE %s -o %s\n", p_current->name, n_current->nickname);
		} else {
			do{
				for(x = 0, nextgroup = data; x < 4 && *nextgroup != '\0'; x++){
					nextgroup = findchar(nextgroup, ' ');
					if(*nextgroup == ' '){
						if(x == 3) *nextgroup = '\0';
						nextgroup++;
					}
				}
				*mode = '\0'; for(; x >= 0; x--) strcat(mode, "o");

				netSend(n_current, "MODE %s -%s %s\n", p_current->name, mode, data);
				data = nextgroup;
			} while(*data != '\0');
		}
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "DEOP");

	return(0); // dont passthru
}


int kick_callback( char *data, int datalen ){ // kick nick from channel
	// KICK nick [message]
	char *msg;

	// data = nick
	// msg = message
	msg = skipword(data);

	if(datalen == 0){
		msgCurrentPage(-1, NULL, MF_SYNTAX, 1, "/KICK nick [message]");
	} else if(p_current->flags.x.chanop){
		netSend(n_current, "KICK %s %s :%s\n", p_current->name, data, msg);
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "KICK");

	return(0); // dont passthru
}


int kickban_callback( char *data, int datalen ){ // kick and ban nick from channel
	// KICKBAN nick [message]
	char *msg;
	int x;

	// data = nick
	// msg = message
	msg = skipword(data);

	if(datalen == 0){
		msgCurrentPage(-1, NULL, MF_SYNTAX, 1, "/KICKBAN nick [message]");
	} else if(p_current->flags.x.chanop){
		x = netSend(n_current, "MODE %s +b %s!*@*\n", p_current->name, data);

  // TODO: grab hostname for nick, replace the A of A.B.C with * and ban *!*@*.B.C

		if(x != -1) netSend(n_current, "KICK %s %s :%s\n", p_current->name, data, msg);
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "KICKBAN");

	return(0); // dont passthru
}


int mode_callback( char *data, int datalen ){ // set channel mode
	// MODE [new_mode]

	if(datalen == 0) return(1); // passthru

	if(p_current->flags.x.chanop){
		if(stringcompare(data, "+b") || stringcompare(data, "+q")){
			display_ban_totals = 1;
			total_bans = total_quiet = 0;
		}
		netSend(n_current, "MODE %s %s\n", p_current->name, data);
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "MODE");

	return(0); // dont passthru
}


int op_callback( char *data, int datalen ){ // op nick in channel
	// OP nick [nick nick ...]
	char *nextgroup, mode[5];
	int x;

	if(datalen == 0){
		msgCurrentPage(-1, NULL, MF_SYNTAX, 1, "/OP nick [nick nick ...]");
	} else if(p_current->flags.x.chanop){
		do{
			for(x = 0, nextgroup = data; x < 4 && *nextgroup != '\0'; x++){
				nextgroup = findchar(nextgroup, ' ');
				if(*nextgroup == ' '){
					if(x == 3) *nextgroup = '\0';
					nextgroup++;
				}
			}
			*mode = '\0'; for(; x >= 0; x--) strcat(mode, "o");

			netSend(n_current, "MODE %s +%s %s\n", p_current->name, mode, data);
			data = nextgroup;
		} while(*data != '\0');
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "OP");

	return(0); // dont passthru
}


int unban_callback( char *data, int datalen ){ // unban nick from channel
	// UNBAN nick_or_hostmask

	if(datalen == 0){
		msgCurrentPage(-1, NULL, MF_SYNTAX, 1, "/UNBAN nick_or_hostmask");
	} else if(p_current->flags.x.chanop){

  // TODO: if only nick is given then
  //	grab hostname for nick, replace the A of A.B.C with * and ban *!*@*.B.C

		netSend(n_current, "MODE %s -b %s\n", p_current->name, data);
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "UNBAN");

	return(0); // dont passthru
}


int unvoice_callback( char *data, int datalen ){ // unvoice nick in channel
	// UNVOICE nick [nick nick ...]
	char *nextgroup, mode[5];
	int x;

	if(datalen == 0){
		msgCurrentPage(-1, NULL, MF_SYNTAX, 1, "/UNVOICE nick [nick nick ...]");
	} else if(p_current->flags.x.chanop){
		do{
			for(x = 0, nextgroup = data; x < 4 && *nextgroup != '\0'; x++){
				nextgroup = findchar(nextgroup, ' ');
				if(*nextgroup == ' '){
					if(x == 3) *nextgroup = '\0';
					nextgroup++;
				}
			}
			*mode = '\0'; for(; x >= 0; x--) strcat(mode, "v");

			netSend(n_current, "MODE %s -%s %s\n", p_current->name, mode, data);
			data = nextgroup;
		} while(*data != '\0');
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "UNVOICE");

	return(0); // dont passthru
}


int voice_callback( char *data, int datalen ){ // voice nick in channel
	// VOICE nick [nick nick ...]
	char *nextgroup, mode[5];
	int x;

	if(datalen == 0){
		msgCurrentPage(-1, NULL, MF_SYNTAX, 1, "/VOICE nick [nick nick ...]");
	} else if(p_current->flags.x.chanop){
		do{
			for(x = 0, nextgroup = data; x < 4 && *nextgroup != '\0'; x++){
				nextgroup = findchar(nextgroup, ' ');
				if(*nextgroup == ' '){
					if(x == 3) *nextgroup = '\0';
					nextgroup++;
				}
			}
			*mode = '\0'; for(; x >= 0; x--) strcat(mode, "v");

			netSend(n_current, "MODE %s +%s %s\n", p_current->name, mode, data);
			data = nextgroup;
		} while(*data != '\0');
	} else msgCurrentPage(-1, NULL, MF_REQUIRES_CHANOP, 1, "VOICE");

	return(0); // dont passthru
}


////////////////////////////////////////////////////////////////////////// GLOBAL


int chanopInit( s_plug *self ){
	if(!plugVersion(0,2,8,4)){
		msgServer(3, NULL, MF_PLUG_REQUIRES, 2, "0.2.8cvs4", "Channel Operator");
		return(0);
	}

	plugHookUser(self, "ban",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &ban_callback);
	plugHookUser(self, "deop",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &deop_callback);
	plugHookUser(self, "kick",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &kick_callback);
	plugHookUser(self, "kickban",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &kickban_callback);
	plugHookUser(self, "mode",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &mode_callback);
	plugHookUser(self, "op",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &op_callback);
	plugHookUser(self, "unban",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &unban_callback);
	plugHookUser(self, "unvoice",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &unvoice_callback);
	plugHookUser(self, "voice",	CMD_ONLINE|CMD_CHANNEL|CMD_JOINED, &voice_callback);

	return(1);
}


void chanopUnload( ){
}
