//	cria - IRC operator plugin
//	Copyright (c) 2003 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// local
int oper_got_password;

////////////////////////////////////////////////////////////////////////// PRIVATE


void oper_password_callback( ){
	oper_got_password = 1;
}
int oper_callback( char *data, int datalen ){ // obtain operator privileges
	// OPER [username]
	char *username, password[33];
	int recon_failed;

	if(datalen){
		username = data;
		skipword(data);
	} else username = n_current->nickname;

	promptSetup(C_IN_FG, C_IN_INFO, "Enter password: ", strlen("Enter password: "),
	password, 32, 1, 1, &oper_password_callback);
	oper_got_password = 0;
	recon_failed = 0;
	while(!oper_got_password && recon_failed != -1)
		recon_failed = listenSockets(RECONNECT_DISABLED);
	if(strlen(password) > 0){
		netSend(n_current, "OPER %s %s\n", username, password);
	}

	return(0); // dont passthru
}


int command_INFO(s_network *network, char *from, char *data, int datalen){
	// * 381 * :You are now an IRC operator

	msgServer(3, network, MF_INFO, 1, skipword(data) + 1);
	return(0); // dont passthru
}
int command_382(s_network *network, char *from, char *data, int datalen){
	// * 382 * <config file> :Rehashing

  // TODO: add a format so it isn't displayed as "<config file> :Rehashing"

	msgServer(3, network, MF_INFO, 1, skipword(data));
	return(0); // dont passthru
}
int command_ERROR(s_network *network, char *from, char *data, int datalen){
	// * 481 * :Permission Denied- You're not an IRC operator
	// * 491 * :You don't have an O-line for the host you're on.

	msgServer(3, network, MF_ERROR, 1, skipword(data) + 1);
	return(0); // dont passthru
}


////////////////////////////////////////////////////////////////////////// GLOBAL


int ircopInit( s_plug *self ){
	if(!plugVersion(0,2,8,7)){
		msgServer(3, NULL, MF_PLUG_REQUIRES, 2, "0.2.8cvs7", "IRC Operator");
		return(0);
	}

	plugHookUser(self, "oper",	CMD_ONLINE, &oper_callback);
	plugHookServerInt(self, 381, &command_INFO);
	plugHookServerInt(self, 382, &command_382);
	plugHookServerInt(self, 481, &command_ERROR);
	plugHookServerInt(self, 491, &command_ERROR);

	return(1);
}


void ircopUnload( ){
}
