//	cria - nick completion plugin
//	Copyright (c) 2002-2003 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// local
char lastquery[LEN_NICKNAME], lastmatch[LEN_NICKNAME];

////////////////////////////////////////////////////////////////////////// PRIVATE


int funcnickcomp_callback( char *data, int datalen ){
	s_nicklist *nicklist;
	char *buffer_top, *query, *end, *nick, temp[LEN_COMMAND+LEN_NICKNAME+10], *self;
	uint len, firsttime, firstword, foundcolon, tries, repair_gap;
	int max_buffer_len;

  // TODO: dynamically allocate temp so there wont be a buffer size restriction (maybe)

	if(p_current->nicklist == NULL) return(0);

	buffer_top = keyGetBuffer(&max_buffer_len);
	if(max_buffer_len > LEN_COMMAND) return(0);
	len = strlen(buffer_top);
	repair_gap = 0;
	if(len > 0){
		foundcolon = 0;
		end = buffer_top + len - 1;

		if(*end == ' ' && *(end-1) == ':') foundcolon = 1;

		if(foundcolon){					// query is first word
			// this case shouldn't fail, dont repair the colon
			*(end-1) = '\0';
			if(strcmp(lastmatch, buffer_top)){

  // TODO: ????

				return(0);
			}
			query = lastquery;
			firstword = 1;
			firsttime = 0;
		} else {
			for(; end != buffer_top; end--)
				if(*end == ' ')
					break;

			if(end != buffer_top){			// query is last word
				repair_gap = 1;
				*end = '\0';
				query = end + 1;
				if(!strcmp(lastmatch, query)){
					firsttime = 0;
					query = lastquery;
				} else firsttime = 1;
				firstword = 0;
			} else {					// query is first word
				query = buffer_top;
				if(*query == '/'){

  // TODO: support command and alias completion

					return(0);
				}
				firstword = 1;
				firsttime = 1;
			}
		}

		len = strlen(query);
		if(len > LEN_NICKNAME) return(0);
	} else {
		query = buffer_top;
		firsttime = 1;
		firstword = 1;
		len = 0;
		end = NULL; // shut gcc up
	}


	if(firsttime) strncpy(lastquery, query, LEN_NICKNAME);

	if(firsttime){
		nicklist = p_current->nicklist;
	} else {
		for(nicklist = p_current->nicklist; nicklist != NULL; nicklist = nicklist->next){
			if(stringcompare(lastmatch, nicklist->nick)){
				nicklist = nicklist->next;
				break;
			}
		}
		if(nicklist == NULL) nicklist = p_current->nicklist;	// cycle to top
	}

	self = p_current->network->nickname;

	nick = NULL;
	tries = 1;
	while(nicklist != NULL){
		if(stringNcompare(query, nicklist->nick, len) && !stringcompare(self, nicklist->nick)){
			nick = nicklist->nick;
			break;
		}
		nicklist = nicklist->next;
		if(nicklist == NULL && tries){
			nicklist = p_current->nicklist;
			tries--;
		}
	}

	if(nick != NULL){
		strncpy(lastmatch, nick, LEN_NICKNAME);
		if(firstword)
			snprintf(temp, LEN_COMMAND+LEN_NICKNAME+10, "%s: ", nick);
		else
			snprintf(temp, LEN_COMMAND+LEN_NICKNAME+10, "%s %s", buffer_top, nick);
		if(strlen(temp) > max_buffer_len){
			msgCurrentPage(-1, NULL, MFP_NICKCOMP_FULL, 0);
			return(0);
		}
		keyBufferReplace(temp);
	} else {
		*lastquery = '\0';
		*lastmatch = '\0';
		if(repair_gap) *end = ' ';
	}

	return(0);
}


////////////////////////////////////////////////////////////////////////// GLOBAL


int nickcompInit( s_plug *self ){
	if(!plugVersion(0,2,0,0)){
		msgServer(3, NULL, MF_PLUG_REQUIRES, 2, "0.2.0", "Nick Completion");
		return(0);
	}

	*lastmatch = '\0';
	*lastquery = '\0';
	plugHookUser(self, "funcnickcomp", CMD_CHANNEL|CMD_JOINED, &funcnickcomp_callback);

	return(1);
}


void nickcompUnload( ){
}
