//	cria - test plugin
//	Copyright (c) 2002-2003 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// local
char *test_str;
char test_char;
int test_num;

////////////////////////////////////////////////////////////////////////// PRIVATE


int test_callback( char *data, int datalen ){
	// TEST something
	s_hist_line *h;
	s_plug *p;
	s_nicklist *nicklist;
	s_plug_server *ps;
	char m_buffer[LEN_BUFFER_MSG];

	if(!strcmp(data, "history")){
		msgCurrentPage(-1, NULL, MF_DEBUG, 1, "Dumping history contents");
		for(h = h_head; h != NULL; h = h->next){
		#ifdef __64BIT__
			snprintf(m_buffer, LEN_BUFFER_MSG, "test HISTORY: 0x%LX <- 0x%LX [%s] -> 0x%LX",
				(uint64)h->prev, (uint64)h, h->text,
				(uint64)h->next);
		#else
			snprintf(m_buffer, LEN_BUFFER_MSG, "test HISTORY: 0x%X <- 0x%X [%s] -> 0x%X",
				(uint)h->prev, (uint)h, h->text,
				(uint)h->next);
		#endif
			msgCurrentPage(-1, NULL, MF_DEBUG, 1, m_buffer);
		}
	} else if(!strcmp(data, "plugs")){
		msgCurrentPage(-1, NULL, MF_DEBUG, 1, "Dumping plugin contents");
		for(p = plug_head; p != NULL; p = p->next){
		#ifdef __64BIT__
			snprintf(m_buffer, LEN_BUFFER_MSG, "test PLUG: 0x%LX [%s] h=0x%LX d=0x%LX -> 0x%LX",
				(uint64)p, p->name,
				#ifndef COREPLUGS
					(uint64)p->handle,
				#else
					(uint64)p->cp,
				#endif
				(uint64)p->deps, (uint64)p->next);
		#else
			snprintf(m_buffer, LEN_BUFFER_MSG, "test PLUG: 0x%X [%s] h=0x%X d=0x%X -> 0x%X",
				(int)p, p->name,
				#ifndef COREPLUGS
					(uint)p->handle,
				#else
					(uint)p->cp,
				#endif
				(uint)p->deps, (uint)p->next);
		#endif
			msgCurrentPage(-1, NULL, MF_DEBUG, 1, m_buffer);
		}
	} else if(!strcmp(data, "plugserver")){
		msgCurrentPage(-1, NULL, MF_DEBUG, 1, "Dumping plugin server commands");
		for(ps = plug_server_head; ps != NULL; ps = ps->next){
			snprintf(m_buffer, LEN_BUFFER_MSG, "test PLUG: %s owns command %s", ps->owner->name,
				ps->command);
			msgCurrentPage(-1, NULL, MF_DEBUG, 1, m_buffer);
		}
	} else if(!strcmp(data, "nicks")){
		nicklist = p_current->nicklist;
		if(nicklist) msgCurrentPage(-1, NULL, MF_DEBUG, 1, "Nicks in channel");
		for(; nicklist != NULL; nicklist = nicklist->next)
			msgCurrentPage(-1, NULL, MF_DEBUG, 1, nicklist->nick);
	} else {
		msgCurrentPage(-1, NULL, MF_SYNTAX, 1, "/TEST something");
	}

	return(0);
}


////////////////////////////////////////////////////////////////////////// GLOBAL


int testInit( s_plug *self ){
	if(!plugVersion(0,2,8,4)){
		msgServer(3, NULL, MF_PLUG_REQUIRES, 2, "0.2.8cvs4", "TEST");
		return(0);
	}

	plugHookUser(self, "test", 0, &test_callback);

	test_str = NULL;
	test_char = 'a';
	test_num = 10;
	plugHookSet(self, "test_str", SET_STR, (void *)&test_str);
	plugHookSet(self, "test_char", SET_CHAR, (void *)&test_char);
	plugHookSet(self, "test_num", SET_NUM, (void *)&test_num);

	return(1);
}


void testUnload( ){
	if(test_str) track_free(test_str, "PLUG test");
}
