//	cria - page, info and input bars
//	Copyright (c) 2001-2010 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global
s_page *left_page, *right_page;
int pb_left_arrow;

// local

////////////////////////////////////////////////////////////////////////// PRIVATE


int get_left_and_right( int x, s_page *page, int net_names ){
	s_page *first_page, *second_page, *last_page;
	int first, len, found_current;
	char n[16];

	first = 1;
	found_current = 0;
	len = 0;
	first_page = second_page = last_page = page;
	for(; page != NULL; last_page = page, page = page->next){
		if(!page->flags.x.hidden){
			if(first >= 0){
				if(first == 1){
					first_page = page;
					second_page = page->next;
				} else second_page = page;
				first--;
			}

			if(page == p_current) found_current = 1;

			////////////////////

			// seperator '|'
			len++;

			// space and network name
			if(net_names && *(page->name) != '!' && page->network != n_current)
				len += 1 + strlen(page->network->name);

			// space, page name and space
			len += 1 + strlen(page->name) + 1;

			if(p_current->bottom_line != p_current->buffer_tail && (page == p_current)){
				// lines-below number and space
				if(page->nr_lines_below > page->new_messages)
					len += snprintf(n, 16, "%d ", page->nr_lines_below);

				// scroll indicator '/\\'
				len += 2;

				// space
				len++;
			}

			if(page->new_messages > 0){
				// msg-counter number
				len += snprintf(n, 16, "%d", page->new_messages);

				// msgtype '+'
				if(page->msgtype == 2) len++;

				// space
				len++;
			}

			////////////////////

			if(page->next != NULL){
				if(len > width-2-x){
					if(!found_current || page == p_current)
						return(get_left_and_right(1, second_page, net_names));
					break;
				}
			} else {
				if(len > width-1-x){
					if(page == p_current){
						left_page = second_page;
						right_page = page;
						return(x);
					} else break;
				}
			}
		}
	}
	left_page = first_page;
	right_page = last_page;
	if(found_current) return(x);
	else return(-1);
}


////////////////////////////////////////////////////////////////////////// GLOBAL


void barsInit( ){
	left_page = right_page = p_server;
	pb_left_arrow = 0;
}


void barsShow( ){
	s_page *page;
	s_network *network;
	int len, n, net_names;
	char ms[55], n_buffer[LEN_BUFFER_MSG], *message;

	msgDisableCursor();

// ***** draw page bar ***** //

	msgDisableScrollRegion();
	_MOVE(1, BAR_PAGE);

	// scan for multiple networks with open pages
	if(var_pb_show_networks){
		net_names = -1;	// allow one network to have pages without displaying network name
		for(network = n_head; network != NULL; network = network->next)
			if(network->nr_pages && network->nr_pages != network->nr_hidden_pages)
				net_names++;
	} else net_names = 0;

//	// get left/right pages
//	if((pb_left_arrow = get_left_and_right(pb_left_arrow, left_page, net_names)) == -1)
//		pb_left_arrow = get_left_and_right(0, p_head, net_names);
//
//	// draw left scroller
//	if(pb_left_arrow){
//		do_color(C_PB_HSCROLL);
//		putchar('<');
//		len = 1;
//	} else
len = 0;

	// display page names
//	page = left_page;
page = p_head;
	while(page != NULL){
		if(!page->flags.x.hidden){
			// seperator
			do_color(C_PB_SEP);
			putchar('|');
			len++;

			// network name
			if(net_names && *(page->name) != '!' && page->network != n_current){
				// uses C_PB_SEP from '|'
				putchar(' ');
				len++;

				do_color(C_PB_NETWORK);
				len += printf("%s", page->network->name);
			}

			// page name
			if(page == p_current) do_color(C_PB_CURRENT);
			else do_color(C_PB_FG);
			len += printf(" %s ", page->name);

			// scroll indicator
			if(p_current->bottom_line != p_current->buffer_tail && (page == p_current)){
				do_color(C_PB_VSCROLL);
				if(page->nr_lines_below > page->new_messages)
					len += printf("%d ", page->nr_lines_below);
				len += printf("/\\");

				do_color(C_PB_CURRENT);
				putchar(' ');
				len++;
			}

			// new messages counter
			if(page->new_messages > 0){
				if(page->msgtype == 0) do_color(C_PB_MSG0);
				else if(page->msgtype == 1) do_color(C_PB_MSG1);
				else do_color(C_PB_MSG2);

				len += printf("%d", page->new_messages);

				if(page->msgtype == 2){
					putchar('+');
					len++;
				}

				do_color(C_PB_SEP);
				putchar(' ');
				len++;
			}
		}

//		if(page == right_page) page = NULL;
//		else
page = page->next;
	}

	// drawing final seperator
	if(p_head != NULL){
		do_color(C_PB_SEP);
		putchar('|');
		len++;
	}

//	if(right_page->next != NULL)
//		len++;

	// draw full bar
	if(len < width){
		do_color(C_PB_BG);
		do{
			putchar(' ');
			len++;
		} while(len < width);
	}

	// draw right scroller
//	if(right_page->next != NULL){
//		do_color(C_PB_HSCROLL);
//		putchar('>');
//	} else {
		do_color(C_PB_BG);
		putchar(' ');
//	}

	fflush(stdout);

// ***** draw info bar ***** //

	msgDisableScrollRegion();
	_MOVE(1, BAR_INFO);

	// display nickname and umode
	len = 0;
	if(n_current != NULL && n_current->nickname != NULL){
		modeToString(ms, n_current->umode);

		do_color(C_IB_POWER);
		if(p_current->flags.x.chanop) putchar('@');
		else if(p_current->flags.x.halfchanop) putchar('%');
		else if(p_current->flags.x.voice) putchar('+');
		else if(p_current->flags.x.quiet) putchar('-');
		else putchar(' ');
		len++;

		do_color(C_IB_SNICK);
		len += printf("%s", n_current->nickname);

		if(*ms != '\0'){
			do_color(C_IB_BRACKET);
			putchar('[');
			len++;

			do_color(C_IB_MODE);
			len += printf("%s", ms);

			do_color(C_IB_BRACKET);
			putchar(']');
			len++;
		}
	}

	// display channel name, mode and topic
	if(p_current->name[0] == '#'){
		do_color(C_IB_CHANNEL);
		len += printf(" %s", p_current->name);

		do_color(C_IB_BRACKET);
		putchar('[');
		len++;

		modeToString(ms, p_current->mode);
		if(*ms != '\0'){
			do_color(C_IB_MODE);
			len += printf("%s", ms);
		}
		if(p_current->mode & MODE_k)
			len += printf(" %s", p_current->host_key);

		if(p_current->mode & MODE_l)
			len += printf(" %d", p_current->limit);

		do_color(C_IB_BRACKET);
		putchar(']');
		len++;

		if(len < width){
			if(p_current->flags.x.joined) message = p_current->topic;
			else message = formats[MF_NOT_IN_CHAN] + 7;

			do_color(C_IB_FG);
			n = width - len + 1 > LEN_BUFFER_MSG ? LEN_BUFFER_MSG : width - len + 1;
			n = snprintf(n_buffer, n, " %s", message);
			printf("%s", n_buffer);
			len += n;
		}

	// display server name and status
	} else if(p_current == p_server){
		if(n_current != NULL){
			if(nr_hidden_pages){
				do_color(C_IB_INFO);
				if(n_current->nr_hidden_pages == nr_hidden_pages)
					len += printf(" (%d hidden)", nr_hidden_pages);
				else
					len += printf(" (%d of %d hidden)",
						n_current->nr_hidden_pages, nr_hidden_pages);
			}
			if(n_current->server_name != NULL){
				do_color(C_IB_HOST);
				len += printf(" %s", n_current->server_name);
			}
		}
	// display page specific information
	} else if(p_current->name[0] == '!'){

 // TODO: call registered handler for current page

	// display nick and hostname
	} else {
		do_color(C_IB_NICK);
		len += printf(" %s", p_current->name);
		if(p_current->host_key){
			do_color(C_IB_HOST);
			len += printf(" %s", p_current->host_key);
		}
	}

	// draw full bar or scroller
	if(len < width){
		do_color(C_IB_BG);
		do{
			putchar(' ');
			len++;
		} while(len < width);
	} else if(len > width){
		_MOVE(width, BAR_INFO);
		do_color(C_IB_SCROLL);
		putchar('>');
	}

	fflush(stdout);

// ***** draw input bar ***** //

	msgDisableScrollRegion();
	_MOVE(1, BAR_INPUT);
	if(input_prompt == NULL){
		do_color(C_IN_BRACKET); putchar('[');
		do_color(C_IN_NETWORK); printf("%s", n_current->name);

		// +1 is needed because termcap starts lines at 1
		// +3 is for the brackets around the network name and space
		input_base = strlen(n_current->name) + 3 + 1;
		if(n_current->socket == 0){
			input_base += 8;
			do_color(C_IN_INFO);
			printf(" offline");
		} else {
			do_color(C_IN_INFO);
			if(n_current->lag == -1){
				// no lag meter
			} else if(n_current->pong_received == -1 || n_current->lag > 9){
				input_base += 4;
				printf(" LAG");
			} else {
				input_base += 2;
				printf(" %d", n_current->lag);
			}

			if(n_current->flags.x.away){
				input_base += 5;
				do_color(C_IN_INFO);
				printf(" AWAY");
			}
		}
		do_color(C_IN_BRACKET); putchar(']');
	} else {
		do_color(input_prompt_color);
		printf("%s", input_prompt);
	}

	if(input_base + input_offset > width){
		input_scrolled = (input_base + input_offset) - width;
		input_offset -= input_scrolled;
	}
	keyDisplayInput();
	// keyDisplayInput() flushes output

	msgEnableCursor();

	fflush(stdout);
}
