//	cria - console color handling
//	Copyright (c) 2001-2003 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// local
int current_bg, current_fg, current_attr;
e_color_item current_color;

////////////////////////////////////////////////////////////////////////// PRIVATE

////////////////////////////////////////////////////////////////////////// GLOBAL


void colorInit( ){
	current_color = C_FG;
	current_bg = -1;
	current_fg = -1;
	current_attr = 0;
}


void do_rev_on( ){
	_ATTR_REVERSE();
}


void do_rev_off( ){
	_ATTR_OFF();
	printf("%s%s", fgcolors[current_fg], bgcolors[current_bg]);
}


void do_color( e_color_item color ){
	s_color *c;
	int attr;

	current_color = color;

	attr = colors[color].attr;

	if(var_color){
		if(current_attr && (current_attr != (attr & UNDERLINE))){
			current_bg = -1;
			current_fg = -1;
			current_attr = 0;
			_ATTR_OFF();
		}
		c = &colors[color];
		if(color!=C_BG && color!=C_PB_BG && color!=C_IB_BG){
			if(attr & BOLD){
				if(current_fg != (int)(c->fg + 8) || current_bg != (int)c->bg){
					current_fg = c->fg + 8;
					current_bg = c->bg;
					printf("%s%s", fgcolors[current_fg],
						bgcolors[current_bg]);
				}
			} else {
				if(current_fg != (int)c->fg || current_bg != (int)c->bg){
					current_fg = c->fg;
					current_bg = c->bg;
					printf("%s%s", fgcolors[current_fg],
						bgcolors[current_bg]);
				}
			}
		} else if(current_bg != (int)c->bg){
			current_bg = c->bg;
			printf("%s", bgcolors[current_bg]);
		}
		if(attr & UNDERLINE){
			current_attr |= UNDERLINE;
			_ATTR_UNDERLINE();
		}
		// reverse is ignored
	} else {
		if(current_attr && (current_attr != attr)){
			current_bg = -1;
			current_fg = -1;
			current_attr = 0;
			_ATTR_OFF();
		}

  // TODO: use smarter attr check above, attr_off should only be used if attr turns off bits in current_attr

		if(attr & BOLD) _ATTR_BOLD();
		if(attr & REVERSE) _ATTR_REVERSE();
		if(attr & UNDERLINE) _ATTR_UNDERLINE();
		if(attr) current_attr = attr;
	}
}


e_color_item get_color( ){
	return(current_color);
}
