//	cria - function prototypes
//	Copyright (c) 2001-2004 Brand Huntsman
//


//
// main.c
//


//
// shutdown.c
//

void	shutdownClient		( char *quit_msg );
void	shutdownBrokenTerm	( );


//
// listen.c
//

void	listenInit			( );

int		listenSockets		( int reconnect );


//
// key.c
//

void	keyInit				( );

void	keyDisplayInput		( );
void	promptSetup			( e_color_item fgcolor, e_color_item prompt_color, char *prompt, int prompt_len,
							  char *buffer, int buffer_len, int hidden, int special, void (*callback)() );
char *	keyGetBuffer		( int *length );
void	keyBufferReplace	( char *new_buffer );
void	keyInsert			( char c );
void	keyBackspace		( );
int		keyGet				( );
int		keyGetCtrlC			( );


//
// net.c
//

void	netInit			( );

int		netRecv			( s_network *network );
int		netSend			( s_network *network, char *data, ... );
int		netGetHost		( uint *src, char *hostname );
int		netOpen			( uint src, int port );
int		netConnect		( s_network *network, s_server *server );
int		netReconnect	( s_network *network );


//
// cmd.c
//

void	cmdInit			( );

void	cmdFromServer	( s_network *network, char *data );
void	cmdFromUser		( char *data );
int		cmdLookup		( char *name );


//
// set.c
//

void	setRawColor	( e_color_item i, e_color_name fg, e_color_name bg, int attr );
int		setMakeNum	( int *num, char *value );
void	setMakeStr	( char **item, char *value );
void *	setItem		( char *item, char *value );
void	getItem		( char *item );


//
// msg.c
//

void		msgInit					( );

void		msgNewDay				( s_page *page, int force );
void		msgRecalcLineLengths	( );
void		msgScrollPage			( s_page *page, int direction );
void		msgDisplayPage			( s_page *page );

void		msgGotoServer		( s_network *network, int type, int count, ... );
void		msgServer			( int msgtype, s_network *network, int type, int count, ... );
void		msgCurrentPage		( int msgtype, s_network *network, int type, int count, ... );
s_page *	msgUnkPage			( s_network *n, char *p, int msgtype, s_network *network, int type, int count, ... );
void		msgPage				( s_page *page, int msgtype, s_network *network, int type, int count, ... );

void		msgEnableScrollRegion	( );
void		msgDisableScrollRegion	( );

void		msgEnableCursor		( );
void		msgDisableCursor	( );


//
// nicks.c
//

void			nicksFree		( s_page *page );
s_nicklist *	nicksAddNick	( s_page *page, char *nick );
int				nicksRemoveNick	( s_page *page, char *nick );


//
// page.c
//

void		pageInit	( );

s_page *	pageCreate	( s_network *network, char *page_name, char *host_key );
void		pageFree	( s_page *page );
void		pageShow	( s_page *page );
s_page *	pageGet		( s_network *network, char *page_name );

void		bufferFreeLine		( s_line *line );
void		bufferClear			( s_page *page );
s_line *	bufferAddLine		( s_page *page, s_network *network, int type );
void		bufferResizePage	( s_page *page );
void		bufferResizeAll		( );
void		bufferAddLineItem	( s_line *line, char *item_text);


//
// history.c
//

void			historyInit		( );

void			historyClear	( );
void			historyAdd		( char *line );
s_hist_line *	historyUp		( );
s_hist_line *	historyDown		( );


//
// servers.c
//

void		serversInit		( );

s_network *	networkCreate	( char *network, char *nickname, uint64 umode, uint auto_connect );
s_network *	networkGet		( char *network );
void		networkFree		( s_network *network );

s_server *	serverCreate	( s_network *network, char *server, uint port );
void		serverFree		( s_network *network, char *server );
void		serverFreeAll	( s_network *network );

uint64		umodeToInt		( uint64 umode, char *ms );
char *		modeToString	( char *ms, uint64 mode );
uint64		cmodeToInt		( s_page *page, char *ms );


//
// bars.c
//

void	barsInit	( );

void	barsShow	( );


//
// config.c
//

int		configLoadFile		( char *filename, int config, int quiet );
void	configEnableColor	( );
void	configDisableColor	( );
void	configLoad			( );
void	configSaveInfo		( );
void	configSaveServers	( );
void	configSaveFormats	( );


//
// plug.c
//

void		plugInit		( );

int			plugLoad		( char *name );
int			plugUnload		( s_plug *plug );
s_plug *	plugGet			( char *name );

int		plugRequire			( s_plug *self, char *name );
void	plugRemoveRequire	( s_plug *self, char *name );
int		plugVersion			( int v_major, int v_minor, int v_sub, int v_pre );

int		plugHookSet			( s_plug *self, char *name, int type, void *value );
int		plugHookSocket		( s_plug *self, int socket, int (*callback)(int socket) );
int		plugHookUser		( s_plug *self, char *command, uint cmdflags, int (*callback)(char *data, int datalen) );
int		plugHookServer		( s_plug *self, char *command, int (*callback)(s_network *network, char *from, char *data, int datalen) );
int		plugHookServerInt	( s_plug *self, int command, int (*callback)(s_network *network, char *from, char *data, int datalen) );
int		plugHookTimer		( s_plug *self, uint id, uint seconds, int (*callback)(uint id) );

int		plugRemoveHookSet		( s_plug *self, char *name );
int		plugRemoveHookSocket	( s_plug *self, int socket );
int		plugRemoveHookUser		( s_plug *self, char *command );
int		plugRemoveHookServer	( s_plug *self, char *command );
int		plugRemoveHookServerInt	( s_plug *self, int command );
int		plugRemoveHookTimer		( s_plug *self, uint id );


//
// ignore.c
//

void	ignoreInit		( );

uint	ignoreFind		( uint type, char *to, char *from, char *host, char *message );
void	ignoreMakeTypes	( char *string, uint type );


//
// user.c
//

/* Generated as cgc_cmds.h */


//
// cgc_formats.c
//


//
// cgc_setformats.c
//


//
// cgc_setvars.c
//


//
// cgc_setcmds.c
//


//
// cgc_colors.c
//


//
// color.c
//

void			colorInit		( );

void			do_rev_on		( );
void			do_rev_off		( );
void			do_color		( e_color_item color );
e_color_item	get_color		( );


//
// misc.c
//

char *	findchar			( char *string, char c );

char *	skipword			( char *data );
char *	skipnick			( char *data );
char *	skipuserhost		( char *data );
char *	skipstring			( char *data );

void	stringtolower		( char *string );
void	stringtoupper		( char *string );

char *	strip_whitespace	( char *string, int side );

int		stringcompare		( char *s1, char *s2 );
int		stringNcompare		( char *s1, char *s2, int max );
char *	findstring			( char *haystack, char *needle );
//char *	findsubstring		( char *haystack, char *needle, int max );
int		stringcomparewild	( char *s, char *wild );

void	stringrevcopy		( char *dest, char *source );

int		is_alphanumeric		( char c );
int		is_ipaddr			( char *string );

int		chop_userhost		( char *userhost );

void	beep_once			( char *data );

uint	cria_atoui			( char *value );

void	out_to_file			( char *prefix, char *message );
void	line_to_file		( s_line *line );


//
// mem-tracker.c
//

#ifdef __DEBUG__
void	track_init		( );
void *	track_malloc	( size_t size, char *location );
void	track_free		( void *ptr, char *location );
void	track_dump		( char *data, int datalen );
#else
#define track_malloc(s, l) malloc(s);
#define track_free(s, l) free(s);
#endif
