//	cria - command history
//	Copyright (c) 2001-2003 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global
s_hist_line *h_head, *h_tail;
int nr_hlines;

// local

////////////////////////////////////////////////////////////////////////// PRIVATE

////////////////////////////////////////////////////////////////////////// GLOBAL


void historyInit( ){
	h_head = NULL;
	h_tail = NULL;
	nr_hlines = 0;
}


void historyClear( ){
}


void historyAdd( char *line ){
	s_hist_line *ln, *ln2;

	for(ln = h_head; ln != NULL; ln = ln->next){
		if(!strcmp(ln->text, line)){
			if(ln != h_tail){
				if(ln == h_head){
					h_head = ln->next;
					h_head->prev = NULL;
				} else {
					ln->prev->next = ln->next;
					ln->next->prev = ln->prev;
				}
				h_tail->next = ln;
				ln->prev = h_tail;
				ln->next = NULL;
				h_tail = ln;
			}
			return;
		}
	}

	ln = (s_hist_line *)track_malloc(sizeof(s_hist_line), "historyAdd line");
	ln->text = (char *)track_malloc(strlen(line)+1, "historyAdd text");
	strcpy(ln->text, line);
	ln->next = NULL;

	if(h_head == NULL){
		h_head = ln;
		ln->prev = NULL;
		nr_hlines++;
	} else {
		ln->prev = h_tail;
		h_tail->next = ln;

		if(nr_hlines == var_history_max){
			ln2 = h_head;
			h_head = h_head->next;
			h_head->prev = NULL;
			track_free(ln2->text, "historyAdd: text");
			track_free(ln2, "historyAdd:");
		} else nr_hlines++;
	}
	h_tail = ln;
}


s_hist_line *historyUp( s_hist_line *last ){
	if(last == NULL) return(h_tail);
	return(last->prev);
}


s_hist_line *historyDown( s_hist_line *last ){
	if(last == NULL) return(h_head);
	return(last->next);
}
