//	cria - help functions for ignore commands
//	Copyright (c) 2003 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global
s_ignore *ignore_head, *ignore_tail;

////////////////////////////////////////////////////////////////////////// PRIVATE

////////////////////////////////////////////////////////////////////////// GLOBAL


void ignoreInit( ){
	ignore_head = ignore_tail = NULL;
}


uint ignoreFind( uint type, char *to, char *from, char *host, char *message ){
	s_ignore *i;

	for(i = ignore_head; i != NULL; i = i->next){
		if(i->type & type){
			if(*i->from == '#'){
				// channel

				if(stringcomparewild(to, i->from)){
					if(i->body == NULL)
						return(1);
					if(stringcomparewild(message, i->body))
						return(1);
				}
			} else {
				// user

				if(stringcomparewild(from, i->from)){
					if(i->host == NULL || stringcomparewild(host, i->host)){
						if(i->body == NULL)
							return(1);
						if(stringcomparewild(message, i->body))
							return(1);
					}
				}
			}
		}
	}
	return(0);
}


void ignoreMakeTypes( char *string, uint type ){
	if(type == 0xffffffff){
		sprintf(string, "ALL ");
	} else {
		string[0] = '\0';
		if(type & IG_NOTICE) strcat(string, "NOTICE ");
		if(type & IG_MESSAGE) strcat(string, "MESSAGE ");
		if(type & IG_PUBLIC) strcat(string, "PUBLIC ");
		if(type & IG_CTCP) strcat(string, "CTCP ");
		if(type & IG_JOIN) strcat(string, "JOIN ");
		if(type & IG_PART) strcat(string, "PART ");
		if(type & IG_QUIT) strcat(string, "QUIT ");
		if(type & IG_NICK) strcat(string, "NICK ");
	}
}
