//	cria - nickname handling
//	Copyright (c) 2001-2003 Brand Huntsman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global

// local

////////////////////////////////////////////////////////////////////////// PRIVATE

////////////////////////////////////////////////////////////////////////// GLOBAL


void nicksFree( s_page *page ){
	s_nicklist *nicklist, *temp;

	if(page == NULL) return;

	nicklist = page->nicklist;
	while(nicklist != NULL){
		temp = nicklist->next;
		track_free(nicklist->nick, "nicksFree: nick");
		track_free(nicklist, "nicksFree:");
		nicklist = temp;
	}
	page->nicklist = NULL;
}


s_nicklist *nicksAddNick( s_page *page, char *nick ){
	s_nicklist *node;

	if(page == NULL) return(NULL);

	node = (s_nicklist *)track_malloc(sizeof(s_nicklist), "nicksAddNick -");
	node->nick = (char *)track_malloc(strlen(nick)+1, "nicksAddNick nick");
	strcpy(node->nick, nick);
	node->next = page->nicklist;
	page->nicklist = node;

	return(node);
}


int nicksRemoveNick( s_page *page, char *nick ){
	// returns 1 if nick found, else 0
	s_nicklist *old, *node;

	if(page == NULL) return(0);

	for(old = node = page->nicklist; node != NULL; old = node, node = node->next){
		if(!strcmp(node->nick, nick)){
			if(node == page->nicklist){
				page->nicklist = node->next;
			} else {
				old->next = node->next;
			}
			track_free(node->nick, "nicksRemoveNick: nick");
			track_free(node, "nicksRemoveNick:");
			return(1);
		}
	}
	return(0);
}
