//	cria - client shutdown
//	Copyright (c) 2001-2003 Brand Huntsman
//


#include <unistd.h>	// close() socket
#include <fcntl.h>	// non-blocking I/O for stdin

#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global

// local

////////////////////////////////////////////////////////////////////////// PRIVATE

////////////////////////////////////////////////////////////////////////// GLOBAL


void shutdownClient( char *quit_msg ){
	s_network *n;

	// called by main.c if ctrl-C is pressed five times.
	// called twice by cmd.c when /QUIT command is used.

	for(n = n_head; n != NULL; n = n->next){
		if(n->socket){
			netSend(n, "QUIT :%s\n", quit_msg);
			close(n->socket);
		}
	}

	_SCROLL_REGION(0, height);
	_MOVE(1, height);
	printf("%s\n", RESET_COLOR);

	// restore settings for stdin
	tcsetattr(0, TCSANOW, &shell_settings);

	// set stdin to blocking i/o
	fcntl(0, F_SETFL, stdin_settings & ~O_NONBLOCK);

	exit(EXIT_SUCCESS);
}


void shutdownBrokenTerm( ){
	printf("%s: terminal is missing required capabilities\n", PROG_NAME);
	exit(EXIT_FAILURE);
}
